org.apache.hc.core5.http.nio.support

## Class AbstractAsyncResponseConsumer<T,E>

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.AbstractAsyncResponseConsumer<T,E>

- Type Parameters:
    `T` - response processing result representation.
    `E` - response entity representation.
  All Implemented Interfaces:
    AsyncDataConsumer, AsyncResponseConsumer<T>, ResourceHolder

      public abstract class AbstractAsyncResponseConsumer<T,E>
      extends Object
      implements AsyncResponseConsumer<T>

  Abstract asynchronous response consumer that makes use of `AsyncEntityConsumer` to process response message content.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractAsyncResponseConsumer(AsyncEntityConsumer<E> dataConsumer)`
    `AbstractAsyncResponseConsumer(Supplier<AsyncEntityConsumer<E>> dataConsumerSupplier)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract T` | `buildResult(HttpResponse response, E entity, ContentType contentType)` Triggered to generate object that represents a result of response message processing.
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `consumeResponse(HttpResponse response, EntityDetails entityDetails, HttpContext httpContext, FutureCallback<T> resultCallback)` Triggered to signal receipt of a response message head.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.hc.core5.http.nio.AsyncResponseConsumer

      `informationResponse`

- - ### Constructor Detail

    - #### AbstractAsyncResponseConsumer

          public AbstractAsyncResponseConsumer(Supplier<AsyncEntityConsumer<E>> dataConsumerSupplier)

    - #### AbstractAsyncResponseConsumer

          public AbstractAsyncResponseConsumer(AsyncEntityConsumer<E> dataConsumer)

  - ### Method Detail

    - #### buildResult

          protected abstract T buildResult(HttpResponse response,
                                           E entity,
                                           ContentType contentType)

      Triggered to generate object that represents a result of response message processing.
      Parameters:
        `response` - the response message.
        `entity` - the response entity.
        `contentType` - the response content type.
      Returns:
        the result of response processing.

    - #### consumeResponse

          public final void consumeResponse(HttpResponse response,
                                            EntityDetails entityDetails,
                                            HttpContext httpContext,
                                            FutureCallback<T> resultCallback)
                                     throws HttpException,
                                            IOException

      Description copied from interface: `AsyncResponseConsumer`
      Triggered to signal receipt of a response message head.
      Specified by:
        `consumeResponse` in interface `AsyncResponseConsumer<T>`
      Parameters:
        `response` - the response message head.
        `entityDetails` - the response entity details or `null` if the response does not enclose an entity.
        `httpContext` - the actual execution context.
        `resultCallback` - the result callback called when response processing has been completed successfully or unsuccessfully.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### updateCapacity

          public final void updateCapacity(CapacityChannel capacityChannel)
                                    throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException` - in case of an I/O error.

    - #### consume

          public final void consume(ByteBuffer src)
                             throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamEnd

          public final void streamEnd(List<? extends Header> trailers)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### failed

          public final void failed(Exception cause)

      Description copied from interface: `AsyncResponseConsumer`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncResponseConsumer<T>`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public final void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.